<?php

use yii\db\Migration;
use yii\db\Schema;

/**
 * Class m240702_142432_create_tables_rotating_product
 */
class m240702_142432_create_tables_rotating_product extends Migration
{
    /**
     * {@inheritdoc}
     */
    public function safeUp()
    {
        $this->createTable('rotating', [
            'id' => 'pk',
            'id_producer' => Schema::TYPE_INTEGER.' NOT NULL',
            'name' => Schema::TYPE_STRING.' NOT NULL',
            'day' => Schema::TYPE_INTEGER.' NOT NULL',
            'status' => Schema::TYPE_INTEGER.' NOT NULL',
        ]);
        $this->addForeignKey('rotating_fk_id_producer', 'rotating', 'id_producer', 'producer', 'id');

        $this->createTable('rotating_product', [
            'id' => 'pk',
            'id_rotating' => Schema::TYPE_INTEGER.' NOT NULL',
            'id_product' => Schema::TYPE_INTEGER.' NOT NULL',
            'position' => Schema::TYPE_INTEGER.' NOT NULL',
            'status' => Schema::TYPE_INTEGER.' NOT NULL',
        ]);
        $this->addForeignKey('rotating_product_fk_id_rotating', 'rotating_product', 'id_rotating', 'rotating', 'id');
        $this->addForeignKey('rotating_product_fk_id_product', 'rotating_product', 'id_product', 'product', 'id');

        $this->createTable('distribution_rotating', [
            'id' => 'pk',
            'id_distribution' => Schema::TYPE_INTEGER.' NOT NULL',
            'id_rotating' => Schema::TYPE_INTEGER.' NOT NULL',
            'id_rotating_product' => Schema::TYPE_INTEGER,
            'status' => Schema::TYPE_INTEGER.' NOT NULL',
        ]);
        $this->addForeignKey('distribution_rotating_fk_id_distribution', 'distribution_rotating', 'id_distribution', 'distribution', 'id');
        $this->addForeignKey('distribution_rotating_fk_id_rotating', 'distribution_rotating', 'id_rotating', 'rotating', 'id');
        $this->addForeignKey('distribution_rotating_fk_id_rotating_product', 'distribution_rotating', 'id_rotating_product', 'rotating_product', 'id');

        $this->addColumn('product_subscription', 'id_rotating', Schema::TYPE_INTEGER);
        $this->addForeignKey('product_subscription_fk_id_rotating', 'product_subscription', 'id_rotating', 'rotating', 'id');
    }

    /**
     * {@inheritdoc}
     */
    public function safeDown()
    {
        $this->dropTable('rotating');
        $this->dropTable('rotating_product');
        $this->dropTable('distribution_rotating');

        $this->dropColumn('product_subscription', 'id_rotating');
    }
}
