<?php

namespace domain\Distribution\Distribution;

use domain\_\AbstractResolver;

class DistributionResolver extends AbstractResolver
{
    protected DistributionRepository $distributionRepository;

    public function loadDependencies(): void
    {
        $this->distributionRepository = $this->loadService(DistributionRepository::class);
    }

    public function getDateLastDistributionIncoming(): ?\DateTime
    {
        $lastDistributionIncoming = $this->distributionRepository->findOneLastDistribution();
        if($lastDistributionIncoming) {
            return $lastDistributionIncoming->getDate();
        }

        return null;
    }
}
