<?php

namespace domain\Distribution\DistributionRotating;

use domain\_\AbstractModule;

class DistributionRotatingModule extends AbstractModule
{
    public function getServices(): array
    {
        return [
            DistributionRotatingDefinition::class,
            DistributionRotatingRepository::class,
            DistributionRotatingBuilder::class,
            DistributionRotatingManager::class
        ];
    }

    public function getDefinition(): DistributionRotatingDefinition
    {
        return DistributionRotatingDefinition::getInstance();
    }

    public function getRepository(): DistributionRotatingRepository
    {
        return DistributionRotatingRepository::getInstance();
    }

    public function getBuilder(): DistributionRotatingBuilder
    {
        return DistributionRotatingBuilder::getInstance();
    }

    public function getManager(): DistributionRotatingManager
    {
        return DistributionRotatingManager::getInstance();
    }
}