<?php

namespace domain\Product\Rotating;

use domain\_\AbstractModule;

class RotatingModule extends AbstractModule
{
    public function getServices(): array
    {
        return [
            RotatingDefinition::class,
            RotatingRepository::class,
            RotatingBuilder::class,
            RotatingResolver::class,
            RotatingManager::class
        ];
    }

    public function getDefinition(): RotatingDefinition
    {
        return RotatingDefinition::getInstance();
    }

    public function getBuilder(): RotatingBuilder
    {
        return RotatingBuilder::getInstance();
    }

    public function getRepository(): RotatingRepository
    {
        return RotatingRepository::getInstance();
    }

    public function getResolver(): RotatingResolver
    {
        return RotatingResolver::getInstance();
    }

    public function getManager(): RotatingManager
    {
        return RotatingManager::getInstance();
    }
}