<?php

namespace domain\Product\RotatingProduct;

use domain\_\AbstractModule;

class RotatingProductModule extends AbstractModule
{
    public function getServices(): array
    {
        return [
            RotatingProductDefinition::class,
            RotatingProductBuilder::class,
            RotatingProductRepository::class,
            RotatingProductManager::class
        ];
    }

    public function getDefinition(): RotatingProductDefinition
    {
        return RotatingProductDefinition::getInstance();
    }

    public function getBuilder(): RotatingProductBuilder
    {
        return RotatingProductBuilder::getInstance();
    }

    public function getRepository(): RotatingProductRepository
    {
        return RotatingProductRepository::getInstance();
    }

    public function getManager(): RotatingProductManager
    {
        return RotatingProductManager::getInstance();
    }
}