<?php

namespace domain\Product\RotatingProduct;

use domain\_\AbstractRepositoryQuery;
use domain\Product\Rotating\Rotating;

class RotatingProductRepositoryQuery extends AbstractRepositoryQuery
{
    protected RotatingProductDefinition $definition;

    public function loadDependencies(): void
    {
        $this->loadDefinition(RotatingProductDefinition::class);
    }

    public function filterByRotating(Rotating $rotating): self
    {
        $this->andWhere(['rotating_product.id_rotating' => $rotating->getId()]);
        return $this;
    }
}